package cse378;
public abstract class AbstractBlock {

	protected final int id;
	protected boolean dirty;
	protected boolean valid;
	
	public AbstractBlock(int id){
		this.id = id;
		this.valid = false;
	}

	public int getId() {
		return this.id;
	}

	/** Mark this entry as valid */
	public void setValid(boolean b) {
		this.valid = b;
	}

	public boolean isValid() {
		return this.valid;
	}
	
	/** hashcode computation
	 * 
	 */ 
	@Override
	public int hashCode(){
		return id;
	}
	
	/**check if this AbstractBlock has been modified
	 *@return true if dirty is set to true
	 */
	public boolean isDirty() {
		return this.dirty;
	}

	public void setDirty(boolean b) {
		this.dirty = b;
	}
}