package cse378;
import java.util.LinkedList;

import cse378.util.BitField;

/** Abstract class representing a line in the cache or TLB
 *  A line has a number of Blocks, and keeps track of which is
 *  the least recently used
 * @author alaska
 *
 */
public abstract class AbstractLine {

	protected int sets;
	protected int tagBits;
	protected int entrySize;
	protected TaggedBlock[] entries;
	protected LinkedList<TaggedBlock> recent;

	public AbstractLine() {
		super();
	}

	/** Verify that an index into the line is valid
	 * 
	 * @param index
	 */
	protected void indexCheck(int index){
		assert(this.sets > index && index >= 0);
	}	

	/**setMRU makes indexed CacheEntry the MRU
	 * @param index set of the cacheEntry
	 */
	public void setMRU(TaggedBlock e) {
		 throw new RuntimeException("Implement Me!");
	}

	/**getLRU return index of least recently used CacheEntry
	 * @param index set of the cacheEntry
	 */
	public TaggedBlock getLRU() {
		 throw new RuntimeException("Implement Me!");
	}

	/**getEntry returns the TaggedBlock indexed by index
	 *@param index AbstractBlock within the cacheline
	 *@return CacheEntry specified by index
	 */
	public TaggedBlock getEntry(int index){
		 throw new RuntimeException("Implement Me!");
	}
	
	/**Pick an AbstractBlock to receive new data.
	 *   
	 * @return allocated AbstractBlock
	 */

	public TaggedBlock allocEntry(){
		 throw new RuntimeException("Implement Me!");
	}
	
	/** Test if there is a valid taggedEntry with a matching Tag
	 * 
	 * @param tag tag in question
	 * 
	 * @return AbstractBlock if found, null otherwise
	 */
	 public TaggedBlock probe(BitField tag){
		 
		 throw new RuntimeException("Implement Me!");
	 }
}