package cse378.address;

import cse378.util.Bits;


/**
 * @author alaska
 *
 */
public abstract class Address {
	protected final PageOffset offset;
	protected final PageNumber page;
	
	Address(PageNumber page, PageOffset offset){
		this.page = page;
		this.offset = offset;
	}
	
	abstract public PageOffset getOffset(); 
	
	abstract public PageNumber getPage();
	
	public String toString(){
		return Bits.toHexString(this.toInt());
	}
	
	public int toInt(){
		int temp = offset.toInt();
		int pagenum = page.toInt();
		int shiftedPageNum = pagenum << offset.getWidth();
		return (shiftedPageNum | temp);
	}
}
