package cse378.cache;
import cse378.AbstractCache;
import cse378.TaggedBlock;
import cse378.address.PhysicalAddress;
import cse378.status.Access;
import cse378.status.Component;
import cse378.status.Status;
import cse378.util.BitField;

/** Cache for CSE 378 lab 5
*/
public class Cache extends AbstractCache{
	
    public Cache(Component c,int lines, int sets, int blockSize) {
		super(lines,sets,blockSize);
		stat = new Status(c);
    }
	
    
	/** Get the line addressed by the index
	 * @param index a BitField specifying the index
	 *
	 * @return AbstractLine addressed by the index
	 */
    @Override
	protected CacheLine getLine(BitField index){
    	return this.cachelines[index.value];
    }

    private void initStatus(PhysicalAddress addr){
    	stat.setAccess(Access.HIT);
    	stat.setAddress(addr);
    }
    
    /**Signal a read from the cache
	*@param addr Physical Address of the load
	*
	*/

	@Override
	public void load(PhysicalAddress addr){
	
		throw new RuntimeException("Implement me!");
	}
	
	/**Signal a write to Cache
	*@param addr physical address of the load target
	*
	*/
	@Override
	public void store(PhysicalAddress addr){
	
		throw new RuntimeException("Implement me!");
	}
	
	/**Compute the index of a particular location
	*@param location location in memory to be wrote to
	*@return integer that indexes into the lines in the cache
	*/
	@Override
	protected BitField computeIndex(PhysicalAddress location){

		throw new RuntimeException("Implement Me!");
	}
	
	/**Compute the tag for a particular location. The tag uniquely identifies
	 * the location given a line ( and set )
	*@param location location in memory to be wrote to
	*@return tag that uniquely identifies a memory location
	*/
	@Override
	protected BitField computeTag(PhysicalAddress location){
		throw new RuntimeException("Implement Me!");
	}
}

