package cse378.cache;
import java.util.Arrays;

import cse378.TaggedBlock;
import cse378.util.Bits;

//CacheBlock class

/** class for CSE 378 AbstractCache lab 5
 */
public class CacheBlock extends TaggedBlock {
	protected final int dataSize;
	protected final int dataBits;

	public CacheBlock(int tagBits, int dataSize, int id){
		super(tagBits,id);
		this.dataSize = dataSize;
		this.dataBits = Bits.log2(dataSize)+2;

	}

	@Override
	public String toString(){
		return "["+this.id+"] tag = "+getTag()+" D|V = "+((this.dirty)? "1": "0")+"|"+((this.valid)? "1":"0");
	}
	
	private void addrCheck(int a){
		assert( a < 0 || a >= this.dataSize );
	}

	@Override
	public boolean equals(Object o) {
		return (o != null) && (o instanceof CacheBlock) && super.equals(o);
	}
}

