package cse378.cache;
//Abstract CacheLine class

import java.util.*;

import cse378.AbstractLine;
import cse378.TaggedBlock;
import cse378.util.BitField;

public class CacheLine extends AbstractLine {
	public CacheLine(int tagBits) {
		this(tagBits, 1, 1);
	}

	public CacheLine(int tagBits, int dataSize){
		this(tagBits, 1,dataSize);
	}

	public CacheLine(int tagBits, int dataSize, int associativity){
		this.sets = associativity;
		this.entrySize = dataSize;
		this.entries = new TaggedBlock[associativity];
		this.recent = new LinkedList<TaggedBlock>();
		this.tagBits = tagBits;
		for(int i = 0; i < associativity; i++){
			throw new RuntimeException("Implement Me!"); 
		}
	}

	@Override
	public String toString(){
		StringBuffer buf = new StringBuffer("\n{");
		for(int i = 0; i < this.entries.length; ++i){
			if(i > 0) buf.append(",\n\t");
			buf.append(this.entries[i]);
		}
		buf.append("}");
		return buf.toString();
	}
	
	/**getEntry returns the AbstractBlock indexed by index
	 *@param index AbstractBlock within the cacheline
	 *@return CacheEntry specified by index
	 */
	public CacheBlock getEntry(int index){
		return (CacheBlock) super.getEntry(index);
	}
	
	/**Pick a CacheEntry to receive new data.
	 * Rely solely on LRU info
	 *  
	 * @return allocated AbstractBlock
	 */
	public CacheBlock allocEntry(){
		return (CacheBlock) super.allocEntry();
	}
	
	/** Test if any of the entries in this line match a Tag
	 * 
	 * @param tag tag in question
	 * 
	 * @return CacheEntry if found, null otherwise
	 */
	public CacheBlock probe(BitField tag){
		throw new RuntimeException("Implement Me!");
	}

}

