package cse378.tlb;

import cse378.TaggedBlock;
import cse378.address.PhysicalPage;
import cse378.address.VirtualPage;
import cse378.util.BitField;

public class TLBEntry extends TaggedBlock {
	PhysicalPage page;
	
	TLBEntry(int tagBits,int id){
		super(tagBits,id);
		this.page = null;
	}
	
	public PhysicalPage getPage(){
		return page;
	}

	public void setPage(PhysicalPage page){
		this.page = page;
	}
	
	@Override
	public int hashCode(){
		return super.hashCode() ^ this.page.hashCode();
	}
	
	@Override
	public boolean equals(Object o){
		if(o == null) return false;
		if(o instanceof TLBEntry){
			TLBEntry te = (TLBEntry) o;
			if(this.page != null) return (this.page.equals(te.page)) && super.equals(te);
			else if(this.page == te.page) return super.equals(te);
			else return false;
		} else {
			return false;
		}
	}
	
	@Override
	public String toString(){
		return "TLBEntry ["+this.id+"] tag = "+getTag()+" page = "+getPage()+" V = "+((this.valid)? "1" : "0");
	}

	@Override
	public VirtualPage getTag() {
		return (VirtualPage) super.getTag();
	}

	@Override
	public boolean hasTag(BitField tag) {
		throw new RuntimeException("TLBEntry uses VirtualPage for tags");
	}

	public boolean hasTag(VirtualPage tag) {
		return super.hasTag(tag);
	}
	
	@Override
	public void setTag(BitField tag) {
		if(tag instanceof VirtualPage){
			this.setTag((VirtualPage)tag);
		} else {
			throw new RuntimeException("TLBEntry uses VirtualPage for tags");
		}
	}

	/** Update the current entry with a new one
	 * @param tag new Tag
	 */

	
	public void setTag(VirtualPage tag) {
		super.setTag(tag);
	}

	@Override
	public void update(BitField tag) {
		throw new RuntimeException("TLBEntry uses VirtualPage for tags");
	}
	
	public void update(VirtualPage tag) {
		super.update(tag);
	}

}
