package cse378.tlb;
//Abstract CacheLine class

import java.util.*;

import cse378.TaggedBlock;
import cse378.AbstractLine;
import cse378.address.PhysicalPage;
import cse378.address.VirtualPage;
import cse378.util.BitField;

/** Class representing a line in the TLB for CSE378 lab 5
 */
public class TLBLine extends AbstractLine {

	public TLBLine(int tagBits, int associativity){
		
		this.sets = associativity;
		this.entrySize = 1;
		this.entries = new TLBEntry[associativity];
		this.recent = new LinkedList<TaggedBlock>();
		this.tagBits = tagBits;
		
		for(int i = 0; i < associativity; i++){
			throw new RuntimeException("Implement Me!");
		}
	}

	/** Added to ensure that only a VirtualPage can be used to probe
	 * @throws RuntimeException
	 */
	@Override
	public TaggedBlock probe(BitField b){
		throw new RuntimeException("Must probe TLBLine with a VirtualPage");
	}
	
	public TLBEntry probe(VirtualPage vp){
		throw new RuntimeException("Implement Me!");
		return null;
	}
	
	@Override
	public String toString(){
		StringBuffer buf = new StringBuffer("\n TLBLine {");
		for(TaggedBlock te : entries){
			buf.append(",\n\t");
			buf.append(te);
		}
		buf.append("}");
		return buf.toString();
	}
	
	
	/**getEntry returns the TLBEntry indexed by index
	 *@param index TLBEntry within the TLBLine
	 *@return TLBEntry specified by index
	 */
	public TLBEntry getEntry(int index){
		return (TLBEntry) getEntry(index);
	}

	@Override
	public TLBEntry allocEntry() {
		return (TLBEntry) super.allocEntry();
	}
	
	
}

